/***************************************************************************
 *             __________               __   ___.
 *   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
 *   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
 *   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
 *   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
 *                     \/            \/     \/    \/            \/
 * $Id: rolo_move_app.S,v 1.0 8/4/02 10:15PM randywood Exp $
 *
 * Copyright (C) 2002 by Randy D. Wood
 *
 * All files in this archive are subject to the GNU General Public License.
 * See the file COPYING in the source tree root for full license agreement.
 *
 * This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
 * KIND, either express or implied.
 *
 ****************************************************************************/
/***************************************************************************
 *
 * Number of long words received in r4
 *
 ***************************************************************************/
    .section .text
    .global	_rolo_move_app,_rolo_move_app_start,_rolo_move_app_end
    .extern _mp3buf,_mp3end
    .align 4
/***************************************************************************
 *
 *  This loop relocates the application move routine to the top of memory
 *
 ***************************************************************************/
_rolo_move_app:
    mov     #15<<4,r6
    ldc     r6,sr                   /* Disable interrupts                               */
    mov.l   move_loop_length,r0     /* Get move loop length (bytes)                     */
    mov.l   mp3end_addr,r7          /* Get top of memory                                */
    sub     r0,r7                   /* Compute loop move to address                     */
    mov     r7,r3                   /* Transfer address to r3                           */
    shlr2   r0                      /* Make it number of long words                     */
    mov.l   move_loop_addr,r8       /* Address of move loop to be relocated             */
move_move_loop:
    mov.l   @r8+,r5                 /* get long word / increment r8 by 4                */
    mov.l   r5,@r7                  /* store long word                                  */
    add     #4,r7                   /* update destination reg                           */
    add     #-1,r0                  /* decrement counter                                */
    cmp/eq  #0,r0                   /* check for zero                                   */
    bf      move_move_loop          /* loop if more to move                             */
    jmp     @r3                     /* jump to application move routine                 */
    nop
/***************************************************************************
 *
 *  This routine moves the application located in mp3buf to the start of RAM
 *
 *  The number of long words to move is received from the calling routine in r4
 *
 ***************************************************************************/
    .align  4
_rolo_move_app_start:	
    mov.l   ram_start_addr,r6       /* start of RAM to destination reg                  */
    mov.l   mp3buf_addr,r5          /* mp3buf to source reg                             */
    mov     r4,r0                   /* number of long words from calling program to r0  */
move_loop:
    mov.l   @r5+,r7                 /* get word from mp3buf / increment r5 by 4         */
    mov.l   r7,@r6                  /* store it in low mem                              */
    add     #4,r6                   /* increment destination addr                       */
    add     #-1,r0                  /* decrement count                                  */
    cmp/eq  #0,r0                   /* check for zero                                   */
    bf      move_loop               /* loop if more to move                             */
    mov.l   start_addr,r9           /* get program entry point                          */
    jmp     @r9                     /* jump to porgram start                            */
    nop
    .align  4
start_addr:  
    .long   0x09000200
mp3buf_addr:
    .long   _mp3buf	
move_loop_addr:
    .long   _rolo_move_app_start
move_loop_length:
    .long   ((_rolo_move_app_end-_rolo_move_app_start)+3)&0xfffffffc
mp3end_addr:  
    .long   _mp3end
ram_start_addr:
    .long   0x09000000  
_rolo_move_app_end:
  